'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Pipeline = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _path = require('path');

var _workerFarm = require('worker-farm');

var _workerFarm2 = _interopRequireDefault(_workerFarm);

var _bluebird = require('bluebird');

var _findOutputPath = require('./findOutputPath');

var _Progress = require('./Progress');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Pipeline = exports.Pipeline = function () {
  function Pipeline(entry, destination) {
    _classCallCheck(this, Pipeline);

    this.entry = entry;
    this.destination = destination;
  }

  _createClass(Pipeline, [{
    key: 'process',
    value: function (_process) {
      function process(_x) {
        return _process.apply(this, arguments);
      }

      process.toString = function () {
        return _process.toString();
      };

      return process;
    }(function () {
      var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(files) {
        var _this = this;

        var workers, jobs, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _loop, _iterator, _step;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                workers = (0, _workerFarm2.default)(require.resolve('./worker'));
                jobs = [];
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 5;

                _loop = function _loop() {
                  var file = _step.value;

                  var output = (0, _findOutputPath.findOutputPath)(file, _this.entry, _this.destination);
                  var job = (0, _bluebird.promisify)(workers)(file, output, _this.destination);
                  jobs.push(job.then(function () {
                    return (0, _path.relative)(process.cwd(), output);
                  }));
                };

                for (_iterator = files[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                  _loop();
                }
                _context.next = 14;
                break;

              case 10:
                _context.prev = 10;
                _context.t0 = _context['catch'](5);
                _didIteratorError = true;
                _iteratorError = _context.t0;

              case 14:
                _context.prev = 14;
                _context.prev = 15;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 17:
                _context.prev = 17;

                if (!_didIteratorError) {
                  _context.next = 20;
                  break;
                }

                throw _iteratorError;

              case 20:
                return _context.finish(17);

              case 21:
                return _context.finish(14);

              case 22:
                _context.next = 24;
                return (0, _Progress.reporter)(jobs, { log: (0, _debug2.default)('unbundle') });

              case 24:
                _workerFarm2.default.end(workers);

              case 25:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[5, 10, 14, 22], [15,, 17, 21]]);
      }));

      return function (_x2) {
        return _ref.apply(this, arguments);
      };
    }())
  }]);

  return Pipeline;
}();