'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tracer = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var twiddle = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(promise, options) {
    var spinner;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            spinner = (0, _ora2.default)(options).start();

            promise.then(function () {
              return spinner.stop().clear();
            });
            _context.next = 4;
            return promise;

          case 4:
            return _context.abrupt('return', _context.sent);

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function twiddle(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _moduleDeps = require('module-deps');

var _moduleDeps2 = _interopRequireDefault(_moduleDeps);

var _streamToPromise = require('stream-to-promise');

var _streamToPromise2 = _interopRequireDefault(_streamToPromise);

var _ora = require('ora');

var _ora2 = _interopRequireDefault(_ora);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var Tracer = exports.Tracer = function () {
  function Tracer(options) {
    _classCallCheck(this, Tracer);

    this.options = {
      ignoreMissing: true,
      cache: Object.create(null),
      packageCache: Object.create(null),
      fileCache: Object.create(null),
      transform: [['babelify', {/* babelrc options */}]]
    };

    Object.assign(this.options, options);
  }

  _createClass(Tracer, [{
    key: 'trace',
    value: function () {
      var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(file) {
        var dependencies, files;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                dependencies = (0, _moduleDeps2.default)(this.options);
                files = new Set();

                dependencies.on('file', function (file) {
                  files.add(file);
                });
                dependencies.end({ file: file });
                _context2.next = 6;
                return twiddle((0, _streamToPromise2.default)(dependencies), { text: 'Tracing dependencies' });

              case 6:
                return _context2.abrupt('return', files);

              case 7:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function trace(_x3) {
        return _ref2.apply(this, arguments);
      }

      return trace;
    }()
  }, {
    key: 'expire',
    value: function expire(file) {
      delete this.options.cache[file];
      delete this.options.packageCache[file];
      delete this.options.fileCache[file];
    }
  }]);

  return Tracer;
}();