'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Unbundle = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = require('path');

var _fs = require('fs');

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _bluebird = require('bluebird');

var _findOutputPath = require('./findOutputPath');

var _without = require('./without');

var _Tracer = require('./Tracer');

var _Watcher = require('./Watcher');

var _Pipeline = require('./Pipeline');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Unbundle = exports.Unbundle = function () {
  function Unbundle(entry, destination) {
    _classCallCheck(this, Unbundle);

    this.log = (0, _debug2.default)('unbundle');

    this.entry = (0, _path.resolve)(process.cwd(), entry);
    this.destination = (0, _path.resolve)(process.cwd(), destination);
    this.log('Entry: ' + this.entry);
    this.log('Destination: ' + this.destination);

    this.tracer = new _Tracer.Tracer();
    this.pipeline = new _Pipeline.Pipeline(this.entry, this.destination);
  }

  _createClass(Unbundle, [{
    key: 'run',
    value: function () {
      var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
        var files;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.tracer.trace(this.entry);

              case 2:
                files = _context.sent;
                _context.next = 5;
                return this.pipeline.process(files);

              case 5:
                return _context.abrupt('return', files);

              case 6:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function run() {
        return _ref.apply(this, arguments);
      }

      return run;
    }()
  }, {
    key: 'watch',
    value: function () {
      var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee3() {
        var _this = this;

        var files;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (this.watcher) this.watcher.close();
                this.watcher = new _Watcher.Watcher();

                _context3.next = 4;
                return this.run();

              case 4:
                files = _context3.sent;

                this.watcher.add(Array.from(files));
                this.log('Watching ' + files.size + ' file' + (files.size === 1 ? '' : 's') + '. Press Ctrl+C to exit.');

                this.watcher.on('change', function () {
                  var _ref3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(file) {
                    var previous, updated, added, removed;
                    return regeneratorRuntime.wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            _this.log('Changed: ' + file);
                            _this.tracer.expire(file);

                            previous = files;
                            _context2.next = 5;
                            return _this.tracer.trace(_this.entry);

                          case 5:
                            updated = files = _context2.sent;
                            added = _without.without.call(updated, previous);

                            _this.watcher.add(Array.from(added));

                            removed = _without.without.call(previous, updated);

                            _this.watcher.unwatch(Array.from(removed));

                            _context2.next = 12;
                            return Promise.all(Array.from(removed).map(function (source) {
                              return (0, _findOutputPath.findOutputPath)(source, _this.entry, _this.destination);
                            }).map(function (output) {
                              return (0, _bluebird.promisify)(_fs.unlink)(output);
                            }));

                          case 12:
                            _context2.next = 14;
                            return _this.pipeline.process([file].concat(_toConsumableArray(added)));

                          case 14:
                          case 'end':
                            return _context2.stop();
                        }
                      }
                    }, _callee2, _this);
                  }));

                  return function (_x) {
                    return _ref3.apply(this, arguments);
                  };
                }());

              case 8:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function watch() {
        return _ref2.apply(this, arguments);
      }

      return watch;
    }()
  }]);

  return Unbundle;
}();